#include "ext.h"

typedef struct _bc_thru
{
	struct object _thru;
	void* in;
	void* out;
} _thru;

void *bc_thru_class;
void *bc_thru_new();
void bang_thru(_thru *b);
void int_thru(_thru *b, long entier);
void float_thru(_thru *b, double flottant);
void list_thru(_thru *b, t_symbol *anything, short argc, t_atom *argv);
void fun_thru(_thru *b, t_symbol *anything, short argc, t_atom *argv);

void main()
{
	setup((t_messlist **)&bc_thru_class, (method)bc_thru_new,0L, (short)sizeof(_thru), 0L, 0);
	addbang((method)bang_thru);
	addint ((method)int_thru);
	addfloat((method)float_thru);
	addmess ((method)list_thru, "list", A_GIMME, 0);
	addmess ((method)fun_thru, "anything",A_GIMME, 0);
}



void *bc_thru_new(t_symbol *s)
{
	_thru *this_thru;
	
	this_thru = (_thru *)newobject(bc_thru_class);
	this_thru->out=outlet_new(this_thru, 0L);	
	return this_thru;
}

void bang_thru(_thru *b)
{
	outlet_bang(b->out);
}

void int_thru(_thru *b, long entier)
{
	outlet_int(b->out,entier);
}

void float_thru(_thru *b, double flottant)
{
	outlet_float(b->out,flottant);
}

void list_thru(_thru *b, t_symbol *anything, short argc, t_atom *argv)
{
	outlet_list(b->out,anything, argc, argv);
}

void fun_thru(_thru *b, t_symbol *anything, short argc, t_atom *argv)
{
	outlet_anything(b->out, anything, argc, argv);
}
